<template>
    <div>
        <div class="row">
            <div class="col-md-6">
                <table class="table table-bordered">
                    <thead>
                    <tr class="warning">
                        <th>PRODUCT LIST</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td>
                            <input type="text" v-model="searchedText" class="form-control" @keyup="searchItem">
                        </td>
                    </tr>
                    <tr v-if="products.length" v-for="(product,index) in products">
                        <td v-on:click="selectProduct(index)">{{ product.name }}</td>
                    </tr>
                    </tbody>
                </table>
            </div>

            <div class="col-md-6">
                <table class="table table-bordered">
                    <thead>
                    <tr class="primary">
                        <th colspan="3">SELECTED PRODUCT LIST</th>
                    </tr>
                    <tr>
                        <th>Product Name</th>
                        <th>Unit</th>
                        <th>Qty</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-if="setProducts.length" v-for="(product,index) in setProducts">
                        <td v-on:click="deSelectProduct(index)">
                            <input type="hidden" :name="'product['+ index +'][id]'" v-model="setProducts[index].id">
                            {{ product.name }}
                        </td>
                        <td>
                            <select :name="'product['+ index +'][unit]'" class="form-control table-input" v-model="setProducts[index].unitId" required>
                                <option v-for="unit in units" :value="unit.id">{{ unit.name }}</option>
                            </select>
                        </td>
                        <td>
                            <input type="number" :name="'product['+ index +'][quantity]'" class="form-control table-input" v-model="setProducts[index].quantity" required>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</template>

<script>

    export default {
        props: ['items','set_items'],

        data: function() {

            return {
                products: [],
                setProducts: [],
                units: [],
                allProducts: [],
                searchedText: "",
            };
        },

        methods: {
            selectProduct: function (index) {
                let item = this.products[index];
                item.unitId = "";
                item.quantity = 1;
                this.setProducts.push(item);
                this.products.splice(index,1);
            },
            deSelectProduct: function (index) {
                let item = this.setProducts[index];
                delete item.unitId;
                delete item.quantity;
                this.products.push(item);
                this.setProducts.splice(index,1);
            },
            removeItem(id){
                console.log(id);
                for(let i=0; i<this.allProducts.length; i++){
                    if(this.allProducts[i].id == id){
                        this.allProducts.splice(i,1);
                    }
                }
            },
            addItem(item){
                this.allProducts.push(item);
            },
            searchItem(){
                if(this.searchedText.length){
                    this.products = [];
                    this.products = this.allProducts.filter((item) => {
                        return item.name.toUpperCase().search(this.searchedText.toUpperCase()) != -1;
                    });
                }else {
                    this.products = this.allProducts;
                }
            }

        },
        created: function() {
            this.products = this.items.rem_products;
            this.allProducts = this.items.rem_products;
            this.setProducts = this.items.cur_products;
            this.units = this.items.units;
        },
        mounted() {

        },


    };
</script>